<script setup lang="ts">
import { ref } from 'vue'

import type { VForm } from 'vuetify/components'
import { type Stock } from '@/types/Stock'

import AddStock from './AddStockDetail.vue'

import { useStockStore } from '../../stores/stock'
import { useStockDetailStore } from '@/stores/stockDetail'
import { useUserStore } from '@/stores/user'
import { useMaterialStore } from '@/stores/material'
import type { Material } from '@/types/Material'
import type { StockDetail } from '@/types/StockDetail'
import { useBranchStore } from '@/stores/branch'

const userStore = useUserStore()
const stockDetailStore = useStockDetailStore()
const materialStore = useMaterialStore()
const branchStore = useBranchStore()
const stockStore = useStockStore()
const form = ref(true)
const refForm = ref<VForm | null>(null)

async function save() {
  for (const material of materialStore.addsomeMaterial) {
    const existingMaterial = materialStore.materials.find(
      (mat) => mat.name.trim().toLowerCase() === material.name.trim().toLowerCase()
    )
    if (existingMaterial) {
      // Update existing material in materials array
      Object.assign(existingMaterial, material)
    } else {
      // Add new material from addsomeMaterial to materials array
      materialStore.materials.push(material)
    }
  }
  console.log('materials: ', materialStore.materials)
  for (const mat of materialStore.materials) {
    console.log('mat: ', mat)
    materialStore.saveMaterial(mat)
  }
  materialStore.getMaterials()
  materialStore.getMaterialsInNewAtt()

  const stock = ref<Stock>(stockStore.editedStock)
  //tran material to stockdetail
  const newMaterials: Material[] = materialStore.materials

  const stockDetails: StockDetail[] = []

  for (const mat of newMaterials) {
    const newStockDetail: StockDetail = {
      id: -1,
      QOH: mat.amount,
      materialId: mat.id,
      balance: mat.amount - mat.minimum,
      StockId: -1
    }

    stockDetails.push(newStockDetail)
  }

  console.log('newStockdetails', stockDetails)
  stock.value = {
    id: -1,
    date: stockStore.formatDate(new Date()),
    stockDetails: stockDetails,
    branchID: userStore.currentUser ? userStore.currentUser.branch.id : 2,
    userID: userStore.currentUser ? userStore.currentUser.id : 2
  }
  stockStore.saveStock(stock.value)
  console.log('stock while saving: ', stock.value)
  stockStore.closeDialog()
}
</script>

<template>
  <v-dialog v-model="stockStore.addAllDialog" persistent width="1440" height="810">
    <v-card>
      <v-card-title>
        <span class="text-h5">Stock INFO</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refForm" v-model="form">
          <v-container>
            <v-row>
              <v-col cols="12" sm="12" md="4">
                <v-text-field v-model.number="stockStore.editedStock.userID" :readonly="stockStore.loading"
                  :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="Checker ID">
                </v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
        <small>*indicates required field</small>
      </v-card-text>
      <v-sheet :height="500" :width="1152" class="ma-6 pa-6"
        :style="{ boxShadow: 'inset 0px 0px 10px 3px rgba(0, 0, 0, 0.5)' }">
        <AddStock v-if="stockStore.addAllDialog"></AddStock>
      </v-sheet>

      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="stockStore.closeDialog()">
          Close
        </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
